import csv
import datetime
import numpy

with open("data.csv", "r") as f:
    reader = csv.reader(f)
    header = reader.next()
    items = list(dict(zip(header, map(int, row))) for row in reader)

with open("deweyclass_count.csv", "r") as f:
    reader = csv.reader(f)
    header = reader.next()
    dewey_count = { }
    for item in list(dict(zip(header, map(int, row))) for row in reader):
        dewey_count[item['deweyClass2']] = item['count']


# 2010
# 2011
# 2012
# 2013
# 2014

# Create feature.
date0 = datetime.date(2010, 1, 1)
def get_date(day):
    return date0 + datetime.timedelta(days = day)

def get_feature_index(day):
    date = get_date(day)
    return date.month - 1 + (date.year - 2010) * 12

matrix = numpy.zeros(( 100, 60 ))

for dewey in range(0, 100):
    print dewey
    feature = numpy.zeros(60)
    for item in items:
        if item['deweyClass'] / 10 == dewey:
            idx = get_feature_index(item['day'])
            feature[idx] += item['count']
    # normalize
    if not dewey in dewey_count:
        print feature
    else:
        feature /= dewey_count[dewey]
        matrix[dewey,:] = feature

numpy.save("matrix", matrix)
