import matplotlib.pyplot as plt
import numpy
import math
from scipy.spatial.distance import pdist, squareform
from scipy.stats import entropy
matrix = numpy.load("matrix.npy")

def KL_Distance(p, q):
    return (entropy(p, qk = q) + entropy(q, qk = p)) / 2.0


# Plot the matrix data
# plt.plot(matrix.T)
# plt.show()

#D = squareform(pdist(matrix, KL_Distance))

from sklearn.decomposition import PCA
from sklearn.manifold import MDS
from sklearn.neural_network import BernoulliRBM
from sklearn.pipeline import Pipeline


# mds = MDS(n_components = , dissimilarity = 'precomputed')
# mds.fit(D)

# pca = PCA(n_components = 2)
# pca.fit(matrix)
# transformed = pca.transform(matrix)
# plt.scatter(transformed[:,0], transformed[:,1])
# plt.show()


matrix = numpy.asmatrix(matrix)
matrix_normalized = matrix + 1e-5
matrix_normalized = matrix_normalized / numpy.mean(matrix_normalized, axis = 1)

mean_timeline = numpy.mean(matrix_normalized, axis = 0)
matrix_normalized -= mean_timeline

#matrix_normalized = matrix
# , learning_rate = 0.001, n_iter = 10000, batch_size = 30
#, learning_rate = 0.001, n_iter = 10000, batch_size = 30
# rbm = BernoulliRBM(n_components = 2)
pipeline = Pipeline([
    ('rbm2', BernoulliRBM(n_components = 2)),
    ('pca', PCA(n_components = 2))
])
pipeline.fit(matrix_normalized)
transformed = pipeline.transform(matrix_normalized)

# transformed[:, 0] /= numpy.max(numpy.abs(transformed[:, 0]))
# transformed[:, 1] /= numpy.max(numpy.abs(transformed[:, 1]))

for i in range(transformed.shape[0]):
    x = transformed[i, 0]
    y = transformed[i, 1]
    dist = math.sqrt(x * x + y * y)
    new_dist = math.pow(dist, 0.5)
    transformed[i, 0] = new_dist / dist * x
    transformed[i, 1] = new_dist / dist * y

transformed[:, 0] /= numpy.max(numpy.abs(transformed[:, 0]))
transformed[:, 1] /= numpy.max(numpy.abs(transformed[:, 1]))

plt.scatter(transformed[:,0], transformed[:,1])
plt.show()

import csv

with open("deweyclass_count.csv", "r") as f:
    reader = csv.reader(f)
    header = reader.next()
    dewey_count = { }
    for item in list(dict(zip(header, map(int, row))) for row in reader):
        dewey_count[item['deweyClass2']] = item['count']

with open("deweyRBM.pde", "w") as f:
    f.write("float deweyRBM[][] = { %s };\n" % ", ".join("{ %d, %f, %f, %d }" % (dewey, transformed[dewey, 0], transformed[dewey, 1], dewey_count[dewey] if dewey in dewey_count else 0) for dewey in range(100)))
