import matplotlib.pyplot as plt
import numpy
from scipy.spatial.distance import pdist, squareform
from scipy.stats import entropy
matrix = numpy.load("matrix.npy")

def KL_Distance(p, q):
    return (entropy(p, qk = q) + entropy(q, qk = p)) / 2.0


# Plot the matrix data
# plt.plot(matrix.T)
# plt.show()

#D = squareform(pdist(matrix, KL_Distance))

from sklearn.decomposition import PCA
from sklearn.manifold import MDS
from sklearn.neural_network import BernoulliRBM
from sklearn.pipeline import Pipeline


# mds = MDS(n_components = , dissimilarity = 'precomputed')
# mds.fit(D)

# pca = PCA(n_components = 2)
# pca.fit(matrix)
# transformed = pca.transform(matrix)
# plt.scatter(transformed[:,0], transformed[:,1])
# plt.show()

# rbm = BernoulliRBM(n_components = 2)
# pipeline = Pipeline([
#     ('rbm1', BernoulliRBM(n_components = 10)),
#     ('rbm2', BernoulliRBM(n_components = 10)),
#     ('rbm3', BernoulliRBM(n_components = 2))
# ])
# pipeline.fit(matrix)
# transformed = pipeline.transform(matrix)
# plt.scatter(transformed[:,0], transformed[:,1])
# plt.show()

transformed = matrix


from minisom import MiniSom
som = MiniSom(50, 50, transformed.shape[1], sigma = 6, learning_rate = 0.1)
som.train_random(transformed, 500)

deweySOM = [ ]

from pylab import text,show,cm,axis,figure,subplot,imshow,zeros
figure(1)
for i in range(transformed.shape[0]):
    winner = som.winner(transformed[i,:])
    deweySOM.append((i, winner[0], winner[1]))
    text(winner[0] + 0.5, winner[1] + 0.5, str(i))
    axis([0,som.weights.shape[0],0,som.weights.shape[1]])
show()

import csv

with open("deweyclass_count.csv", "r") as f:
    reader = csv.reader(f)
    header = reader.next()
    dewey_count = { }
    for item in list(dict(zip(header, map(int, row))) for row in reader):
        dewey_count[item['deweyClass2']] = item['count']

with open("deweySOM.pde", "w") as f:
    f.write("int somWidth = %d;\n" % som.weights.shape[0])
    f.write("int somHeight = %d;\n" % som.weights.shape[1])
    f.write("int deweySOM[][] = { %s };\n" % ", ".join("{ %d, %d, %d, %d }" % (dewey, x, y, dewey_count[dewey] if dewey in dewey_count else 0) for dewey, x, y in deweySOM))
